import dune.perftool.blockstructured.quadrature
import dune.perftool.blockstructured.argument
import dune.perftool.blockstructured.geometry
import dune.perftool.blockstructured.spaces
import dune.perftool.blockstructured.basis

from dune.perftool.pdelab.quadrature import pymbolic_quadrature_position
# from dune.perftool.pdelab.geometry import to_global
from dune.perftool.blockstructured.spaces import lfs_inames
from dune.perftool.blockstructured.geometry import (pymbolic_jacobian_inverse_transposed,
                                                    pymbolic_jacobian_determinant,
                                                    pymbolic_facet_jacobian_determinant,
                                                    to_global)

from dune.perftool.pdelab import PDELabInterface


class BlockStructuredInterface(PDELabInterface):
    def __init__(self):
        PDELabInterface.__init__(self)

    #
    # Local function space related generator functions
    #

    def lfs_inames(self, element, restriction, number=None, context=''):
        return lfs_inames(element, restriction, number, context)

    #
    # Geometry related generator functions
    #

    def pymbolic_spatial_coordinate(self):
        return to_global(pymbolic_quadrature_position())

    def pymbolic_jacobian_determinant(self):
        return pymbolic_jacobian_determinant()

    def pymbolic_jacobian_inverse_transposed(self, i, j, restriction):
        return pymbolic_jacobian_inverse_transposed(i,j,restriction)

    def pymbolic_facet_jacobian_determinant(self):
        return pymbolic_facet_jacobian_determinant()
