from dune.perftool.generation import (backend,
                                      kernel_cached,
                                      valuearg,get_global_context_value)
from dune.perftool.pdelab.argument import CoefficientAccess
from dune.perftool.blockstructured.tools import micro_index_to_macro_index
from loopy.types import NumpyType
from pymbolic.primitives import Variable, Call
import pymbolic.primitives as prim

# TODO rename prim
@kernel_cached
@backend(interface="pymbolic_coefficient", name="blockstructured")
def pymbolic_coefficient(container, lfs, index):
    # TODO introduce a proper type for local function spaces!
    if isinstance(lfs, str):
        valuearg(lfs, dtype=NumpyType("str"))

    # If the LFS is not yet a pymbolic expression, make it one
    from pymbolic.primitives import Expression
    if not isinstance(lfs, Expression):
        lfs = Variable(lfs)

    return Call(CoefficientAccess(container), (lfs, micro_index_to_macro_index(index),))
